.nolist
.nolist
ifndef @Model
  include \masm32\include\masm32rt.inc
endif
DefCon MACRO name, val
ifndef name
	ifidn <">, @SubStr(<val>, 1, 1)
		.data
		name db val, 0
	else
		name equ val
	endif
endif
ENDM
; ------------------------------------------------------------------------------------------------------------------------------
DefCon	UseMenu, 1	; put 0 if you don't need the menus
DefCon	UseButton2, 1	; put 0 for no second button
DefCon	MyChoice, 1	; pick a number from the list below
UseEdit	= 1		; Choose your options, then
UseListbox	= 2		; hit F6 to assemble and run
UseNothing	= 0		; this application (Esc = exit) 
; ------------------------------------------------------------------------------------------------------------------------------
ifndef CASE_WM_CHAR
CASE_WM_CHAR MACRO				; define here what to do in case of a keystroke in the edit field
  CASE WM_CHAR
  .if wParam==VK_RETURN				; user hit Enter
	xor eax, eax
	ret									; return 0 to suppress the insertion of a new line
  .endif
ENDM
endif
ifndef CASE_WM_KEYUP
CASE_WM_KEYUP MACRO				; same for releasing the key
  CASE WM_KEYUP
  .if wParam==VK_F1
	MsgBox 0, chr$("You really expect help from hitting F1?", 10, "Go and find VK_F1 in the source!"), offset txApp, MB_OK
	invoke SetFocus, hEdit
  .elseif wParam==VK_RETURN			; comment out or replace with your own handler
	invoke SetWindowText, hEdit, chr$("RETURN inserts this text, try F1 now")
  .endif
ENDM
endif
WinMain	PROTO:DWORD,:DWORD,:DWORD,:DWORD
SubEdit	PROTO:DWORD,:DWORD,:DWORD,:DWORD

; equates and constants
sm	equ invoke SendMessage, 	; for faster typing ;-)
IdEscape	= VK_ESCAPE		; press Esc to quit your window
IdMenuNew	= 1000			; ID menu item New
IdMenuSave	= 1001			; ID menu item Save
IdMenuCopy	= 1100			; ID menu item Copy
IdEdit	= 2000			; depending on MyChoice, either
IdListbox	= 2000			; IdEdit or IdListbox will be used
IdButton1	= 2001
IdButton2	= 2002
IdStatic	= 2003
DefCon AppX,		200		; main window X and Y
DefCon AppY,		200
DefCon AppWidth,		400		; window width and height
DefCon AppHeight,	200
DefCon ButtonWidth,	72		; button sizes in pixels
DefCon ButtonHeight,	24

.data
ClassAppWin	db "MyClass", 0
ClassButton	db "button", 0
ClassStatic	db "static", 0
DefCon txButton1, "PushMe"
if UseButton2
  if MyChoice eq UseEdit
    DefCon txButton2, "SayHi"
  else
    DefCon txButton2, "Open"
  endif
endif
DefCon txStatic,	"Welcome"
DefCon txApp,	"Tiny Win App"
MyAccels	ACCEL <FCONTROL or FVIRTKEY, VK_S, IdMenuSave>
	ACCEL <FVIRTKEY, VK_F5, IdButton1>
	ACCEL <FCONTROL or FVIRTKEY, VK_N, IdMenuNew>
LastAccel	ACCEL <FVIRTKEY, VK_ESCAPE, IdEscape>

.data?
hInstance	HINSTANCE ?
CommandLine	LPSTR ?
hButton1	HWND ?
hButton2	HWND ?
ifndef hStatic
  hStatic	HWND ?
endif
hListbox	equ hEdit
ifndef hEdit
  hEdit	HWND ?
endif
ifndef hMainWnd
  hMainWnd	HWND ?
endif
hMenu	HWND ?
hM1	HWND ?
hM2	HWND ?
hButFnt	HWND ?
haccl	HWND ?
opSubClass	DWORD ?

.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	invoke GetCommandLine
	invoke WinMain, hInstance, NULL, eax, SW_SHOWDEFAULT
	invoke ExitProcess, eax

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
	call ClearLocVars	; set all local variables to zero
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, offset WndProc
;	 mov wc.cbClsExtra, NULL		not needed, ClearLocVars
;	 mov wc.cbWndExtra, NULL		has cleared them already
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_BTNFACE+1
	mov wc.lpszClassName, offset ClassAppWin
	invoke LoadIcon, hInst, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, WS_EX_CLIENTEDGE,
		addr ClassAppWin, addr txApp,
		WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_VISIBLE,
		AppX, AppY, AppWidth, AppHeight,
		NULL, NULL, hInst, NULL
	mov hwnd, eax
	mov hMainWnd, eax
	.Repeat
		invoke GetMessage, addr msg, NULL, 0, 0
		.break .if eax==0
		invoke TranslateAccelerator, hwnd, haccl, addr msg
		.if eax==0		; not an accelerator
			invoke TranslateMessage, addr msg
			invoke DispatchMessage, addr msg
		.endif
	.Until 0
	mov eax, msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rc:RECT
  or esi, -1		; let's try to crash Windows
  or edi, -1
  or ebx, -1
	SWITCH uMsg
	CASE WM_DESTROY
		invoke PostQuitMessage, NULL

	CASE WM_CREATE
		; -------------------- create keyboard shortcuts -------------------- 

		mov eax, 1+(dword ptr LastAccel-dword ptr MyAccels)/(SIZEOF ACCEL)
		invoke CreateAcceleratorTable, addr MyAccels, eax	; eax needed because of a [url=http://www.masm32.com/board/index.php?topic=10435.msg76444#msg76444]MASM Version 9.0 bug[/url]
		mov haccl, eax

		; -------------------- create menus and sub-menus -------------------- 
		if UseMenu
		mov hMenu, rv(CreateMenu)				; create the main menu
		mov hM1, rv(CreateMenu)				; plus two
		mov hM2, rv(CreateMenu)				; sub menus
		invoke AppendMenu,hMenu, MF_POPUP, hM1,chr$("&File")
		invoke AppendMenu, hM1, MF_STRING, IdMenuNew, chr$("&New",9,"Ctrl+N")
		invoke AppendMenu, hM1, MF_STRING, IdMenuSave, chr$("&Save",9,"Ctrl+S")
		invoke AppendMenu,hMenu, MF_POPUP, hM2,chr$("&Edit")
		invoke AppendMenu, hM2, MF_STRING, IdMenuCopy, chr$("&Copy",9,"Ctrl+C")
		invoke SetMenu, hWnd, hMenu			; attach menu to main window
		endif
		; -------------------- create controls: buttons, edit window or listbox, static ---------- 
		invoke GetStockObject, ANSI_VAR_FONT	; get a cute little font for the controls
		mov hButFnt, eax
		if MyChoice eq UseEdit
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("edit"), NULL, 
			WS_CHILD or WS_VISIBLE or WS_BORDER\
			or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE, 0, 0, 0, 0,
			hWnd, IdEdit, hInstance, NULL
		mov hEdit, eax							; we have created an edit window
;		sm eax, WM_SETFONT, hButFnt, 1	; you may choose the small font here
		invoke SetFocus, hEdit					; give the focus to the edit window

		invoke SetWindowLong, hEdit,			; we subclass the edit control
		GWL_WNDPROC, SubEdit
		mov opSubClass, eax					; the old pointer

		elseif MyChoice eq UseListbox
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("listbox"), NULL, 
			WS_CHILD or WS_VISIBLE or WS_BORDER	or WS_VSCROLL or \	;LBS_SORT or
			LBS_NOINTEGRALHEIGHT or LBS_USETABSTOPS or LBS_SORT,
			0, 0, 0, 0,
			hWnd, IdListbox, hInstance, NULL
		mov hListbox, eax						; we have created a listbox
		sm hListbox, WM_SETFONT, hButFnt, 1	; the small font looks better here
		sm hListbox, LB_DIR, DDL_READONLY, chr$("*.asm")	; put something nice inside
		endif
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton1, 
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton1, hInstance, NULL
		mov hButton1, eax						; upper button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		if UseButton2
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton2,
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton2, hInstance, NULL
		mov hButton2, eax						; lower button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		endif
		invoke CreateWindowEx, NULL, addr ClassStatic, addr txStatic,
			WS_CHILD or WS_VISIBLE or ES_LEFT, 0, 0, 0, 0,
			hWnd, IdStatic, hInstance, NULL
		mov hStatic, eax						; static window under buttons created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font

	CASE WM_COMMAND					; react here to menus and controls
		movzx eax, word ptr wParam			; the Ids are in the lowword of wParam
		switch eax
		if UseMenu
		case IdMenuNew						; feel free to call your own stuff here...
			sm hStatic, WM_SETTEXT, 0, chr$("You clicked New")
		endif
		case IdMenuSave
			sm hStatic, WM_SETTEXT, 0,
			chr$("You either clicked Save, or you pressed Control S")
		case IdMenuCopy
			sm hStatic, WM_SETTEXT, 0, chr$("You clicked Copy")
		case IdButton1
			call Button1		; [url=+0]click here[/url] to jump to this procedure
		if UseButton2
		case IdButton2
			call Button2
		endif
		case IdEdit
			sm hStatic, WM_SETTEXT, 0, chr$("Type some text")
		case IdEscape
;			MsgBox 0, chr$("Sure to exit?"), addr txApp, MB_YESNO
;			.if eax==IDYES
				sm hWnd, WM_CLOSE, 0, 0	; Escape: exit without asking!
				return 0
;			.endif
		default
			; MsgBox 0, chr$("Other control"), addr txApp, MB_OK
		endsw

	CASE WM_SIZE			; resize controls
		invoke GetClientRect, hWnd, addr rc
		push esi
		push ebx
		mov esi, rc.right
		sub esi, ButtonWidth	; editbox = window width minus button width
		mov ebx, rc.bottom
		sub ebx, 6
		invoke MoveWindow, hEdit, 3, 3, esi, ebx, 1
		add esi, 5				; buttons 5 pixels right of editbox
		mov ebx, rc.right
		sub ebx, esi
		sub ebx, 3
		invoke MoveWindow, hButton1, esi, 5, ebx, ButtonHeight, 1
		if UseButton2
		  invoke MoveWindow, hButton2, esi, 8+ButtonHeight, ebx, ButtonHeight, 1
		endif
		mov edx, rc.bottom
		sub edx, ButtonHeight*(1+UseButton2)+15
		invoke MoveWindow, hStatic, esi, 11+ButtonHeight*(1+UseButton2), ebx, edx, 1
		ifdef WmSizeHandler
			WmSizeHandler
		endif
		pop ebx
		pop esi

	ifdef WmPaintHandler
		CASE WM_PAINT
		WmPaintHandler
	endif

	ENDSW
	
	invoke DefWindowProc, hWnd, uMsg, wParam, lParam
	ret
WndProc endp

ifndef Button1		; you may include the skeleton at the end of another application; see [url=\masm32\MasmBasic\TinyPlotter.asc]TinyPlotter[/url] for an example
Button1 proc
	MsgBox 0, chr$("Thank you so much for pushing me!"), addr txApp, MB_OK
	ret
Button1 endp		; [url=+1]back to wm_command[/url]
endif

if UseButton2
ifndef Button2		; you may include the skeleton at the end of another application; see [url=\masm32\MasmBasic\TinyPlotter.asc]TinyPlotter[/url] for an example
Button2 proc
  if MyChoice eq UseEdit
	sm hEdit, WM_SETTEXT, 0, addr txStatic
  elseif MyChoice eq UseListbox
	call LbOpen
  endif
 ret
Button2 endp		; [url=+1]back to wm_command[/url]
endif
endif

if MyChoice eq UseListbox
LbOpen proc uses esi
LOCAL buffer [MAX_PATH]:BYTE
  lea esi, buffer
  sm hListbox, LB_GETCURSEL, 0, 0
  .if sdword ptr eax<0
	MsgBox 0, "No file selected", "Hi", MB_OK
  .else
	sm hListbox, LB_GETTEXT, eax, esi
	MsgBox 0, esi, "Open this file?", MB_YESNO
	.if eax==IDYES
		invoke ShellExecute, 0, 0, esi, 0, 0, SW_SHOWNORMAL
	.endif
  .endif
  ret
LbOpen endp
elseif MyChoice eq UseEdit
SubEdit proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	SWITCH uMsg
;	CASE WM_KEYDOWN	; in general, no processing needed
	CASE_WM_CHAR		; the macros are defined
	CASE_WM_KEYUP		; on top of the file
	ENDSW
; subclassing finished, continue with default handler
  invoke CallWindowProc, opSubClass, hwnd, uMsg, wParam, lParam
  ret
SubEdit endp
endif

ClearLocVars proc	; put "call ClearLocals" as first instruction after LOCALS - eax unchanged on exit
  push eax		; do not use with uses esi etc - push them manually behind the call!
  lea eax, [esp+8]		; pushed eax and ret address
  mov esp, ebp		; base page of calling procedure
  align 4		; 74 instead of 123 cycles on Celeron M, no effect on P4
@@:
  push 0		; 120 bytes: 196 cycles on P4
  cmp esp, eax		; rep stosd??
  ja @B
  sub esp, 8		; 19 bytes with align 4
  pop eax
  ret
ClearLocVars endp
end start

RichMasm options
OPT_Icon	Smiley	; see \Masm32\RichMasm\Icons
OxPT_Assembler	JWasm	; remove the x if you have [url=http://www.japheth.de/JWasm.html]JWasm[/url] installed, it's faster
OPT_Tmp2Asm	1	; JJ only, for [url=\masm32\MasmBasic\TinyPlotter.asc]TinyPlotter[/url]